"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.StyledAppendToBodyOptionsWrapper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

var _useRefRect = _interopRequireDefault(require("../../hooks/useRefRect/useRefRect"));

var _usePlaceAbove = _interopRequireDefault(require("../../hooks/usePlaceAbove/usePlaceAbove"));

var _Wrapper = _interopRequireDefault(require("../Wrapper/Wrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var StyledAppendToBodyOptionsWrapper = function StyledAppendToBodyOptionsWrapper(props, ref) {
  var className = props.className,
      children = props.children,
      placeOptionsAbove = props.placeOptionsAbove,
      parentRect = props.parentRect,
      otherProps = _objectWithoutProperties(props, ["className", "children", "placeOptionsAbove", "parentRect"]);

  return _react.default.createElement(_Wrapper.default, _extends({
    className: className,
    ref: ref
  }, otherProps), children);
};

exports.StyledAppendToBodyOptionsWrapper = StyledAppendToBodyOptionsWrapper;
exports.StyledAppendToBodyOptionsWrapper = StyledAppendToBodyOptionsWrapper = (0, _react.forwardRef)(StyledAppendToBodyOptionsWrapper);

var AppendToBodyOptionsWrapper = function AppendToBodyOptionsWrapper(props) {
  var className = props.className,
      children = props.children,
      parentRef = props.parentRef,
      filteredOptions = props.filteredOptions,
      updateOn = props.updateOn,
      StyledAppendToBodyOptionsWrapper = props.StyledAppendToBodyOptionsWrapper,
      otherProps = _objectWithoutProperties(props, ["className", "children", "parentRef", "filteredOptions", "updateOn", "StyledAppendToBodyOptionsWrapper"]);

  var ref = (0, _react.useRef)(null);
  var parentRect = (0, _useRefRect.default)(parentRef, updateOn);
  var optionWrapperRect = (0, _useRefRect.default)(ref, updateOn);
  var placeOptionsAbove = (0, _usePlaceAbove.default)(parentRect, optionWrapperRect, updateOn);

  if (placeOptionsAbove && children) {
    filteredOptions = filteredOptions.reverse();
    children = _react.default.cloneElement(children, {
      itemList: filteredOptions
    });
  }

  return _react.default.createElement(StyledAppendToBodyOptionsWrapper, _extends({
    className: className,
    ref: ref,
    placeOptionsAbove: placeOptionsAbove,
    parentRect: parentRect
  }, otherProps), children);
};

AppendToBodyOptionsWrapper.defaultProps = {
  updateOn: []
};
AppendToBodyOptionsWrapper.propTypes = {
  parentRef: _propTypes.default.object.isRequired,
  filteredOptions: _AppPropTypes.default.itemList.isRequired,
  updateOn: _propTypes.default.array.isRequired,
  StyledAppendToBodyOptionsWrapper: _AppPropTypes.default.element.isRequired,
  styles: _AppPropTypes.default.styles.isRequired
};
var _default = AppendToBodyOptionsWrapper;
exports.default = _default;