"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _mocks = require("../../mocks");

var _AppendToBodyOptionsWrapper = _interopRequireDefault(require("./AppendToBodyOptionsWrapper"));

var _useRefRect = _interopRequireDefault(require("../../hooks/useRefRect/useRefRect"));

var _usePlaceAbove = _interopRequireDefault(require("../../hooks/usePlaceAbove/usePlaceAbove"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

jest.mock('../../hooks/useRefRect/useRefRect', function () {
  return function () {
    return {
      "bottom": 80,
      "height": 80,
      "left": 0,
      "right": 200,
      "top": 0,
      "width": 200,
      "x": 0,
      "y": 600
    };
  };
});
jest.mock('../../hooks/usePlaceAbove/usePlaceAbove', function () {
  return function () {
    return true;
  };
});
global.console.error = jest.fn();
it('renders', function () {
  var parentRef = _react.default.createRef();

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_AppendToBodyOptionsWrapper.default, {
    styles: _mocks.mockStyles,
    className: "test",
    parentRef: parentRef,
    filteredOptions: _mocks.mockItemList,
    StyledAppendToBodyOptionsWrapper: _mocks.MockElement
  }, _react.default.createElement(_mocks.MockElement, null)));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it('forwards ref', function () {
  var parentRef = _react.default.createRef();

  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_AppendToBodyOptionsWrapper.default, {
    styles: _mocks.mockStyles,
    className: "test",
    parentRef: parentRef,
    filteredOptions: [],
    StyledAppendToBodyOptionsWrapper: _mocks.MockElement
  }));
  expect(parentRef.current).toBeDefined();
});