"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _styledComponents = require("../styledComponents/styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CheckRadio = function CheckRadio(rawProps, ref) {
  var props = rawProps.massaged ? rawProps : rawProps.massageData(rawProps);
  var type = props.multiple ? 'checkbox' : 'radio';
  var values = props.selection.map(function (item) {
    return item.value;
  });
  var useSwitch = props.options.length === 2 && !props.multiple && props.options.map(function (option) {
    return option.value;
  }).every(function (val) {
    return ['false', 'true'].includes(val.toLowerCase());
  });

  var onChange = function onChange(e) {
    var value = useSwitch ? String(e.target.checked) : String(e.target.value);

    if (props.multiple) {
      value = props.selection.map(function (option) {
        return option.value;
      });

      if (e.target.checked) {
        value.push(String(e.target.value));
      } else {
        value.splice(value.indexOf(String(e.target.value)), 1); // Remove
      }
    }

    props.onChange({
      target: {
        value: value,
        name: props.name
      }
    });
  };

  var options = useSwitch ? [props.options.find(function (option) {
    return option.value.toLowerCase() === 'true';
  })] : props.options;

  if (props.disabled) {
    onChange = function onChange() {};
  }

  var Checkable = props.multiple ? props.components.CheckBox : useSwitch ? props.components.Switch : props.components.Radio;
  return _react.default.createElement("div", {
    className: props.className,
    style: props.style,
    ref: ref
  }, options.map(function (option) {
    return _react.default.createElement(Checkable, {
      type: type,
      name: props.name,
      value: option.value,
      disabled: props.disabled,
      onChange: onChange,
      checked: values.includes(option.value),
      label: option.label,
      title: option.label,
      multiple: props.multiple,
      toggle: useSwitch,
      styles: props.styles,
      key: option.value
    });
  }));
};

CheckRadio = (0, _react.forwardRef)(CheckRadio);
CheckRadio.defaultProps = _objectSpread({}, _defaultProps.default, {
  style: {},
  components: _objectSpread({}, _defaultProps.default.components, {
    CheckBox: _styledComponents.CheckBox,
    Radio: _styledComponents.Radio,
    Switch: _styledComponents.Switch
  })
});
CheckRadio.propTypes = {
  style: _propTypes.default.object.isRequired,
  disabled: _propTypes.default.bool,
  multiple: _propTypes.default.bool.isRequired,
  selection: _propTypes.default.oneOfType([_AppPropTypes.default.rawValue.isRequired, _propTypes.default.arrayOf(_AppPropTypes.default.rawValue).isRequired, _AppPropTypes.default.itemList.isRequired]).isRequired,
  options: _propTypes.default.oneOfType([_AppPropTypes.default.rawItemList.isRequired, _AppPropTypes.default.itemList.isRequired]).isRequired,
  massageData: _propTypes.default.func.isRequired,
  massaged: _propTypes.default.bool,
  onChange: _propTypes.default.func.isRequired,
  components: _propTypes.default.shape({
    CheckBox: _AppPropTypes.default.element.isRequired,
    Radio: _AppPropTypes.default.element.isRequired,
    Switch: _AppPropTypes.default.element.isRequired
  }).isRequired,
  styles: _AppPropTypes.default.styles.isRequired
};
var _default = CheckRadio;
exports.default = _default;