"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var noop = function noop() {};

var ItemList = function ItemList(props) {
  var renderItem = function renderItem(item) {
    return _react.default.createElement(props.Item, {
      item: item,
      removable: props.removable,
      key: item.value,
      styles: props.styles
    });
  };

  var hasItems = !!props.itemList.length;
  var onMouseDown = hasItems ? props.onClick : noop;
  var onMouseOver = hasItems ? props.onMouseOver : noop;
  return _react.default.createElement("ul", {
    className: props.className,
    onMouseDown: onMouseDown,
    onMouseOver: onMouseOver
  }, props.itemList.map(renderItem), !hasItems && props.noItemsText && _react.default.createElement(props.Item, {
    item: {
      value: '',
      label: props.noItemsText
    },
    removable: false,
    styles: props.styles
  }));
};

ItemList.defaultProps = {
  removable: false
};
ItemList.propTypes = {
  itemList: _AppPropTypes.default.itemList.isRequired,
  removable: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  noItemsText: _propTypes.default.string,
  onMouseOver: _propTypes.default.func,
  Item: _AppPropTypes.default.element.isRequired,
  styles: _AppPropTypes.default.styles.isRequired
};
var _default = ItemList;
exports.default = _default;