"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _mocks = require("../../mocks");

var _ItemList = _interopRequireDefault(require("./ItemList"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var onClick = jest.fn();
var onMouseOver = jest.fn();
it('renders', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_ItemList.default, {
    styles: _mocks.mockStyles,
    itemList: _mocks.mockItemList,
    Item: _mocks.MockElement
  }));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it('renders removable', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_ItemList.default, {
    styles: _mocks.mockStyles,
    itemList: _mocks.mockItemList,
    Item: _mocks.MockElement,
    removable: true
  }));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it('renders no items', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_ItemList.default, {
    styles: _mocks.mockStyles,
    itemList: [],
    Item: _mocks.MockElement,
    removable: true,
    noItemsText: "None",
    onClick: onClick,
    onMouseOver: onMouseOver
  }));
  wrapper.find('ul').simulate('mouseDown');
  wrapper.find('ul').simulate('mouseOver');
  expect(onClick).not.toBeCalled();
  expect(onMouseOver).not.toBeCalled();
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it('should click', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_ItemList.default, {
    styles: _mocks.mockStyles,
    itemList: _mocks.mockItemList,
    Item: _mocks.MockElement,
    onClick: onClick
  }));
  wrapper.find('ul').simulate('mouseDown');
  expect(onClick).toBeCalled();
});
it('should mouseOver', function () {
  var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_ItemList.default, {
    styles: _mocks.mockStyles,
    itemList: _mocks.mockItemList,
    Item: _mocks.MockElement,
    onMouseOver: onMouseOver
  }));
  wrapper.find('ul').simulate('mouseOver');
  expect(onMouseOver).toBeCalled();
});