"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireWildcard(require("../../utils/AppPropTypes"));

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _useWindowWidth = _interopRequireDefault(require("../../hooks/useWindowWidth/useWindowWidth"));

var _Select = _interopRequireDefault(require("../Select/Select"));

var _CheckRadio = _interopRequireDefault(require("../CheckRadio/CheckRadio"));

var _styledComponents = require("../styledComponents/styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var hasOverflownX = function hasOverflownX(element) {
  return element.scrollWidth > element.clientWidth;
};

var NewInput = function NewInput(rawProps) {
  var props = rawProps.massageData(rawProps);
  var checkRadioRef = (0, _react.useRef)(null);
  var windowWidth = (0, _useWindowWidth.default)();

  var _useState = (0, _react.useState)(props.options.length < props.checkRadioMaxCount && !props.creatable),
      _useState2 = _slicedToArray(_useState, 1),
      canCheckRadio = _useState2[0];

  var _useState3 = (0, _react.useState)(canCheckRadio),
      _useState4 = _slicedToArray(_useState3, 2),
      isLoading = _useState4[0],
      setIsLoading = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isOverflown = _useState6[0],
      setIsOverflown = _useState6[1];

  (0, _react.useEffect)(function () {
    if (canCheckRadio) setIsOverflown(hasOverflownX(checkRadioRef.current, windowWidth));
    if (isLoading) setIsLoading(false);
  }, [props.options, props.creatable, windowWidth, canCheckRadio, isLoading]);
  var hideCheckRadio = isLoading || isOverflown;
  var checkRadioStyle = {
    whiteSpace: 'nowrap',
    overflow: 'visible'
  };

  if (hideCheckRadio) {
    checkRadioStyle = _objectSpread({}, checkRadioStyle, {
      opacity: 1,
      height: 0,
      overflowY: 'hidden'
    });
  }

  var _props$components = props.components,
      CheckRadio = _props$components.CheckRadio,
      Select = _props$components.Select;
  return [canCheckRadio && _react.default.createElement(CheckRadio, _extends({
    style: checkRadioStyle,
    ref: checkRadioRef
  }, props, {
    massaged: true,
    key: "CheckRadio"
  })), (!canCheckRadio || isOverflown) && _react.default.createElement(Select, _extends({}, props, {
    massaged: true,
    key: "Select"
  }))];
};

NewInput.defaultProps = _objectSpread({}, _defaultProps.default, {
  components: _objectSpread({}, _defaultProps.default.components, {
    Select: _Select.default,
    CheckRadio: _CheckRadio.default,
    CheckBox: _styledComponents.CheckBox,
    Radio: _styledComponents.Radio,
    Switch: _styledComponents.Switch
  })
});
NewInput.propTypes = _objectSpread({}, _AppPropTypes.simpleNewInputPropTypes, {
  components: _propTypes.default.shape(_objectSpread({}, _AppPropTypes.simpleNewInputPropTypes.components, {
    Select: _AppPropTypes.default.element.isRequired,
    CheckRadio: _AppPropTypes.default.element.isRequired,
    CheckBox: _AppPropTypes.default.element.isRequired,
    Radio: _AppPropTypes.default.element.isRequired,
    Switch: _AppPropTypes.default.element.isRequired
  })).isRequired
});
var _default = NewInput;
exports.default = _default;