"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _AppPropTypes = require("../../utils/AppPropTypes");

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _last2 = _interopRequireDefault(require("lodash/last"));

var _inRange2 = _interopRequireDefault(require("lodash/inRange"));

var _styledComponents = require("../styledComponents/styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ENTER_KEY = 13;
var ESCAPE = 27;
var SPACE = 32;
var BACKSPACE = 8;
var DELETE = 46;
var ARROW_UP = 38;
var ARROW_DOWN = 40;
var ARROW_LEFT = 37;
var ARROW_RIGHT = 39;
var NUM_LETTER_START = 48;
var NUM_LETTER_END = 111;
var SEMI_COLON = 186;
var EQUAL_SIGN = 187;
var COMMA = 188;
var DASH = 189;
var PERIOD = 190;
var FORWARD_SLASH = 191;
var OPEN_BRACKET = 219;
var BACK_SLASH = 220;
var CLOSE_BRAKET = 221;
var SINGLE_QUOTE = 222;

var targetValue = function targetValue(e) {
  return String(e.target.value || e.target.getAttribute('val') || '');
};

var Select = function Select(rawProps) {
  var props = rawProps.massaged ? rawProps : rawProps.massageData(rawProps);
  var selfRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      areOptionsOpen = _useState2[0],
      setAreOptionsOpen = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = _slicedToArray(_useState3, 2),
      searchText = _useState4[0],
      setSearchText = _useState4[1];

  var _useState5 = (0, _react.useState)(props.text.placeholder),
      _useState6 = _slicedToArray(_useState5, 2),
      placeholder = _useState6[0],
      setPlacholder = _useState6[1];

  var _useState7 = (0, _react.useState)(),
      _useState8 = _slicedToArray(_useState7, 2),
      optionHighlighted = _useState8[0],
      setOptionHighlighted = _useState8[1];

  var hasOptions = !!props.options.length;
  var hasSelection = !!props.selection.length;
  var filteredOptions = props.filterOptions(searchText, props.selection, props.options);
  var showSelection = props.multiple || !areOptionsOpen; // Multiple: always show. Single: show when options are closed

  var showSearch = props.multiple || areOptionsOpen || !props.selection.length; // Multiple: always show. Single: show when options are open or when nothing is selected (placeholder should be shown)

  var styles = _objectSpread({
    width: selfRef && selfRef.current ? selfRef.current.offsetWidth : 0,
    multiple: props.multiple,
    disabled: props.disabled,
    hasSelection: hasSelection,
    hasOptions: hasOptions,
    optionHighlighted: optionHighlighted,
    rightToLeft: props.rightToLeft
  }, props.styles);

  if (props.creatable && searchText && !filteredOptions.some(function (item) {
    return item.value === searchText;
  })) {
    filteredOptions.push({
      value: searchText,
      label: props.text.create + " \"".concat(searchText, "\"")
    });
  }

  if (!filteredOptions.map(function (option) {
    return option.value;
  }).includes(optionHighlighted)) {
    var newOptionHighlighted = filteredOptions.length ? filteredOptions[0].value : undefined;
    if (newOptionHighlighted !== optionHighlighted) setOptionHighlighted(newOptionHighlighted);
  }

  var callOnChange = function callOnChange(value) {
    props.onChange({
      target: {
        value: value,
        name: props.name
      }
    });
  }; // Events


  var onFocus = function onFocus(e) {
    setAreOptionsOpen(true);
    setPlacholder(!props.multiple && props.selection.length ? props.selection[0].label // Set placeholder to current selection on single select
    : props.text.placeholder);
    props.onFocus(e);
  };

  var onBlur = function onBlur(e) {
    setAreOptionsOpen(false);
    setSearchText('');
    props.onBlur(e);
  };

  var onOptionClick = function onOptionClick(e) {
    var value = targetValue(e);

    if (props.multiple) {
      value = props.selection.map(function (option) {
        return option.value;
      });
      value.push(targetValue(e));
      e.preventDefault(); // Keep options open on multi select
    }

    callOnChange(value);
  };

  var onRemove = function onRemove(e) {
    if (props.removable && e.target.classList.contains('remove')) {
      e.preventDefault(); // Prevent click from opening options

      setPlacholder(props.text.placeholder); // Reset placeholder for single select

      var value = [];

      if (props.multiple) {
        value = props.selection.map(function (option) {
          return option.value;
        });
        value.splice(value.indexOf(targetValue(e)), 1); // Remove
      }

      callOnChange(value);
    }
  };

  var onHoverOption = function onHoverOption(e) {
    var value = targetValue(e);

    if (value && value !== optionHighlighted) {
      setOptionHighlighted(value);
    }
  };

  var onKeyDown = function onKeyDown(e) {
    var openKeys = [ENTER_KEY, ARROW_UP, ARROW_DOWN, ARROW_LEFT, ARROW_RIGHT, SPACE, SEMI_COLON, EQUAL_SIGN, COMMA, DASH, PERIOD, FORWARD_SLASH, OPEN_BRACKET, BACK_SLASH, CLOSE_BRAKET, SINGLE_QUOTE];
    if (!areOptionsOpen && ((0, _inRange2.default)(e.keyCode, NUM_LETTER_START, NUM_LETTER_END) || openKeys.includes(e.keyCode))) setAreOptionsOpen(true);

    switch (e.keyCode) {
      case ENTER_KEY:
        if (areOptionsOpen && optionHighlighted) {
          onOptionClick({
            target: {
              value: optionHighlighted
            },
            preventDefault: e.preventDefault
          });
          setOptionHighlighted();
          setSearchText('');
          if (!props.multiple) e.target.blur(); // Close options on single select
        }

        break;

      case ARROW_UP:
        if (areOptionsOpen && filteredOptions.length && optionHighlighted) {
          var index = filteredOptions.map(function (option) {
            return option.value;
          }).indexOf(optionHighlighted) - 1;
          if (index >= 0) setOptionHighlighted(filteredOptions[index].value);
        }

        break;

      case ARROW_DOWN:
        if (areOptionsOpen && filteredOptions.length && optionHighlighted) {
          var _index = filteredOptions.map(function (option) {
            return option.value;
          }).indexOf(optionHighlighted) + 1;

          if (_index < filteredOptions.length) setOptionHighlighted(filteredOptions[_index].value);
        }

        break;

      case ESCAPE:
        if (areOptionsOpen) setAreOptionsOpen(false);
        setSearchText('');
        break;

      case BACKSPACE:
      case DELETE:
        if (!searchText && props.selection.length) {
          var input = document.createElement("input");
          input.value = (0, _last2.default)(props.selection).value;
          input.classList.add('remove');
          onRemove({
            target: input,
            preventDefault: e.preventDefault
          });
        }

        break;

      default:
        break;
    }
  };

  if (props.disabled) {
    onFocus = onBlur = onOptionClick = onKeyDown = onRemove = onHoverOption = function onHoverOption() {};
  }

  var _props$components = props.components,
      HtmlFieldData = _props$components.HtmlFieldData,
      Wrapper = _props$components.Wrapper,
      Selection = _props$components.Selection,
      SelectionList = _props$components.SelectionList,
      OptionList = _props$components.OptionList,
      Option = _props$components.Option,
      Search = _props$components.Search,
      SelectionWrapper = _props$components.SelectionWrapper,
      OptionWrapper = _props$components.OptionWrapper,
      AppendToBodyOptionsWrapper = _props$components.AppendToBodyOptionsWrapper,
      StyledAppendToBodyOptionsWrapper = _props$components.StyledAppendToBodyOptionsWrapper;

  var optionList = _react.default.createElement(OptionList, {
    itemList: filteredOptions,
    onClick: onOptionClick,
    onMouseOver: onHoverOption,
    Item: Option,
    noItemsText: props.text.noOptions,
    styles: styles
  });

  return _react.default.createElement(Wrapper, {
    styles: styles,
    ref: selfRef
  }, _react.default.createElement(HtmlFieldData, {
    name: props.name,
    itemList: props.selection
  }), _react.default.createElement(SelectionWrapper, {
    onFocus: onFocus,
    onBlur: onBlur,
    styles: styles,
    areOptionsOpen: areOptionsOpen,
    SelectionList: showSelection && _react.default.createElement(SelectionList, {
      itemList: props.selection,
      onClick: onRemove,
      removable: !props.disabled && props.removable,
      Item: Selection,
      styles: styles
    }),
    Search: _react.default.createElement(Search, {
      hide: !showSearch,
      placeholder: placeholder,
      searchText: searchText,
      onKeyDown: onKeyDown,
      onChange: function onChange(e) {
        return setSearchText(targetValue(e));
      },
      styles: styles
    })
  }), !props.appendToBody && areOptionsOpen && _react.default.createElement(_styledComponents.DivRelative, null, _react.default.createElement(OptionWrapper, {
    styles: styles
  }, optionList)), props.appendToBody && areOptionsOpen && _reactDom.default.createPortal(_react.default.createElement(AppendToBodyOptionsWrapper, {
    styles: styles,
    parentRef: selfRef,
    filteredOptions: filteredOptions,
    StyledAppendToBodyOptionsWrapper: StyledAppendToBodyOptionsWrapper
  }, optionList), document.body));
};

Select.defaultProps = _defaultProps.default;
Select.propTypes = _AppPropTypes.simpleNewInputPropTypes;
var _default = Select;
exports.default = _default;