"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppPropTypes = _interopRequireDefault(require("../../utils/AppPropTypes"));

var _expand = _interopRequireDefault(require("./expand.png"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var SelectionWrapper = function SelectionWrapper(props) {
  var searchRef = (0, _react.useRef)(null);

  var onFocus = function onFocus(e) {
    if (!props.areOptionsOpen) {
      props.onFocus(e);
      searchRef.current.focus();
    } else {
      e.target.blur(); // Close if already open options
    }
  };

  var onBlur = function onBlur(e) {
    if (e.target.classList.contains('search')) {
      setTimeout(function () {
        // Call blur after focus event
        props.onBlur(e);
      });
    }
  };

  var onSearchClick = function onSearchClick(e) {
    if (props.areOptionsOpen) {
      // Call blur on search click
      e.preventDefault();
      searchRef.current.blur();
    }
  };

  var Search = _react.default.cloneElement(props.Search, {
    onClick: onSearchClick,
    ref: searchRef
  });

  return _react.default.createElement("div", {
    className: props.className,
    tabIndex: props.styles.disabled ? 'false' : '-1',
    onFocus: onFocus,
    onBlur: onBlur
  }, _react.default.createElement("div", null, props.SelectionList, Search), _react.default.createElement("span", {
    className: "divider"
  }), _react.default.createElement("img", {
    className: "expand",
    src: props.expandSrc,
    alt: "expand"
  }));
};

SelectionWrapper.defaultProps = {
  expandSrc: _expand.default
};
SelectionWrapper.propTypes = {
  onFocus: _propTypes.default.func.isRequired,
  onBlur: _propTypes.default.func.isRequired,
  expandSrc: _propTypes.default.string.isRequired,
  areOptionsOpen: _propTypes.default.bool.isRequired,
  Search: _AppPropTypes.default.element.isRequired,
  SelectionList: _propTypes.default.oneOfType([_AppPropTypes.default.element.isRequired, _propTypes.default.bool]),
  styles: _AppPropTypes.default.styles.isRequired
};
var _default = SelectionWrapper;
exports.default = _default;