"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _addonActions = require("@storybook/addon-actions");

var _mocks = require("../../mocks");

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _styledComponents = require("../styledComponents/styledComponents");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var selectionList = _react.default.createElement(_styledComponents.SelectionList, {
  itemList: _defaultProps.default.selection,
  onClick: (0, _addonActions.action)('onRemove'),
  removable: !_defaultProps.default.disabled && _defaultProps.default.removable,
  Item: _styledComponents.Selection,
  styles: _mocks.mockStyles
});

var search = _react.default.createElement(_styledComponents.Search, {
  hide: false,
  placeholder: _defaultProps.default.placeholder,
  searchText: '',
  onKeyDown: (0, _addonActions.action)('onKeyDown'),
  onChange: (0, _addonActions.action)('onChange'),
  styles: _mocks.mockStyles
});

(0, _react2.storiesOf)('(Internal) SelectionWrapper', module).add('closed', function () {
  return _react.default.createElement(_styledComponents.SelectionWrapper, {
    onFocus: (0, _addonActions.action)('onFocus'),
    onBlur: (0, _addonActions.action)('onBlur'),
    styles: _mocks.mockStyles,
    areOptionsOpen: false,
    SelectionList: selectionList,
    Search: search
  });
});
(0, _react2.storiesOf)('(Internal) SelectionWrapper', module).add('open', function () {
  return _react.default.createElement(_styledComponents.SelectionWrapper, {
    onFocus: (0, _addonActions.action)('onFocus'),
    onBlur: (0, _addonActions.action)('onBlur'),
    styles: _mocks.mockStyles,
    areOptionsOpen: true,
    SelectionList: selectionList,
    Search: search
  });
});

var styles = _objectSpread({}, _mocks.mockStyles, {
  disabled: true
});

(0, _react2.storiesOf)('(Internal) SelectionWrapper', module).add('disabled', function () {
  return _react.default.createElement(_styledComponents.SelectionWrapper, {
    onFocus: (0, _addonActions.action)('onFocus'),
    onBlur: (0, _addonActions.action)('onBlur'),
    styles: styles,
    areOptionsOpen: false,
    SelectionList: _react.default.createElement(_styledComponents.SelectionList, {
      itemList: _defaultProps.default.selection,
      onClick: (0, _addonActions.action)('onRemove'),
      removable: !_defaultProps.default.disabled && _defaultProps.default.removable,
      Item: _styledComponents.Selection,
      styles: styles
    }),
    Search: _react.default.createElement(_styledComponents.Search, {
      placeholder: _defaultProps.default.placeholder,
      searchText: '',
      onKeyDown: (0, _addonActions.action)('onKeyDown'),
      onChange: (0, _addonActions.action)('onChange'),
      styles: styles
    })
  });
});