"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MockInput = exports.MockElement = exports.mockEvent = exports.mockItemList = exports.mockItem = exports.mockStyles = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = _interopRequireDefault(require("./utils/defaultProps"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var noop = function noop() {};

var mockStyles = _objectSpread({
  width: '600px',
  multiple: false,
  disabled: false,
  hasSelection: false,
  hasOptions: true,
  optionHighlighted: [],
  rightToLeft: false
}, _defaultProps.default.styles);

exports.mockStyles = mockStyles;
var mockItem = {
  value: '42',
  label: 'Meaning of life'
};
exports.mockItem = mockItem;
var mockItemList = [{
  value: '1',
  label: 'Item 1'
}, {
  value: '2',
  label: 'Item 2'
}, {
  value: '3',
  label: 'Item 3'
}, {
  value: '4',
  label: 'Item 4'
}, {
  value: '5',
  label: 'Item 5'
}];
exports.mockItemList = mockItemList;
var mockEvent = {
  preventDefault: noop
};
exports.mockEvent = mockEvent;

var MockElement = function MockElement(props) {
  return _react.default.createElement("div", {
    "data-props": props
  });
};

exports.MockElement = MockElement;

var MockInput = function MockInput(props) {
  return _react.default.createElement("input", {
    "data-props": props
  });
};

exports.MockInput = MockInput;