"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.simpleNewInputPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var item = _propTypes.default.shape({
  value: _propTypes.default.string.isRequired,
  label: _propTypes.default.string.isRequired
});

var rawValue = _propTypes.default.oneOfType([_propTypes.default.string.isRequired, _propTypes.default.bool.isRequired, _propTypes.default.number.isRequired]);

var rawItem = _propTypes.default.shape({
  value: rawValue.isRequired,
  label: rawValue.isRequired
});

var AppPropTypes = {
  item: item,
  itemList: _propTypes.default.arrayOf(item),
  element: _propTypes.default.oneOfType([_propTypes.default.element, _propTypes.default.func, _propTypes.default.shape({
    current: _propTypes.default.element
  })]),
  rawValue: rawValue,
  rawItem: rawItem,
  rawItemList: _propTypes.default.arrayOf(rawItem),
  styles: _propTypes.default.shape({
    fontSize: _propTypes.default.string.isRequired,
    borderRadius: _propTypes.default.string.isRequired,
    paddingTop: _propTypes.default.string.isRequired,
    paddingBottom: _propTypes.default.string.isRequired,
    paddingLeft: _propTypes.default.string.isRequired,
    paddingRight: _propTypes.default.string.isRequired,
    selection: _propTypes.default.shape({
      paddingTop: _propTypes.default.string.isRequired,
      paddingBottom: _propTypes.default.string.isRequired,
      paddingLeft: _propTypes.default.string.isRequired,
      paddingRight: _propTypes.default.string.isRequired
    }).isRequired,
    option: _propTypes.default.shape({
      paddingTop: _propTypes.default.string.isRequired,
      paddingBottom: _propTypes.default.string.isRequired,
      paddingLeft: _propTypes.default.string.isRequired,
      paddingRight: _propTypes.default.string.isRequired
    }).isRequired,
    checkRadio: _propTypes.default.shape({
      borderWidth: _propTypes.default.string.isRequired,
      marginBetween: _propTypes.default.string.isRequired,
      labelMargin: _propTypes.default.string.isRequired,
      paddingTop: _propTypes.default.string.isRequired,
      paddingBottom: _propTypes.default.string.isRequired,
      paddingLeft: _propTypes.default.string.isRequired,
      paddingRight: _propTypes.default.string.isRequired
    }).isRequired,
    search: _propTypes.default.shape({
      width: _propTypes.default.string.isRequired
    }).isRequired,
    icon: _propTypes.default.shape({
      width: _propTypes.default.string.isRequired
    }).isRequired,
    colors: _propTypes.default.shape({
      primary: _propTypes.default.string.isRequired,
      secondary: _propTypes.default.string.isRequired,
      highlight: _propTypes.default.string.isRequired,
      warning: _propTypes.default.string.isRequired,
      disabled: _propTypes.default.string.isRequired,
      background: _propTypes.default.string.isRequired
    }).isRequired
  })
};
var simpleNewInputPropTypes = {
  onChange: _propTypes.default.func.isRequired,
  onBlur: _propTypes.default.func.isRequired,
  onFocus: _propTypes.default.func.isRequired,
  name: _propTypes.default.string.isRequired,
  selection: _propTypes.default.oneOfType([AppPropTypes.rawValue.isRequired, _propTypes.default.arrayOf(AppPropTypes.rawValue).isRequired, AppPropTypes.itemList.isRequired]).isRequired,
  options: _propTypes.default.oneOfType([AppPropTypes.rawItemList.isRequired, AppPropTypes.itemList.isRequired]).isRequired,
  placeholder: _propTypes.default.string.isRequired,
  multiple: _propTypes.default.bool.isRequired,
  disabled: _propTypes.default.bool.isRequired,
  creatable: _propTypes.default.bool.isRequired,
  removable: _propTypes.default.bool.isRequired,
  appendToBody: _propTypes.default.bool.isRequired,
  rightToLeft: _propTypes.default.bool.isRequired,
  filterOptions: _propTypes.default.func.isRequired,
  massageData: _propTypes.default.func.isRequired,
  optionKeys: _propTypes.default.arrayOf(_propTypes.default.string).isRequired,
  checkRadioMaxCount: _propTypes.default.number.isRequired,
  text: _propTypes.default.shape({
    placeholder: _propTypes.default.string.isRequired,
    noOptions: _propTypes.default.string.isRequired,
    create: _propTypes.default.string.isRequired
  }).isRequired,
  components: _propTypes.default.shape({
    HtmlFieldData: AppPropTypes.element.isRequired,
    Wrapper: AppPropTypes.element.isRequired,
    Selection: AppPropTypes.element.isRequired,
    SelectionList: AppPropTypes.element.isRequired,
    OptionList: AppPropTypes.element.isRequired,
    Option: AppPropTypes.element.isRequired,
    Search: AppPropTypes.element.isRequired,
    SelectionWrapper: AppPropTypes.element.isRequired,
    OptionWrapper: AppPropTypes.element.isRequired,
    AppendToBodyOptionsWrapper: AppPropTypes.element.isRequired,
    StyledAppendToBodyOptionsWrapper: AppPropTypes.element.isRequired
  }).isRequired,
  styles: AppPropTypes.styles.isRequired
};
exports.simpleNewInputPropTypes = simpleNewInputPropTypes;
var _default = AppPropTypes;
exports.default = _default;