"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _HtmlFieldData = _interopRequireDefault(require("../components/HtmlFieldData/HtmlFieldData"));

var _AppendToBodyOptionsWrapper = _interopRequireDefault(require("../components/AppendToBodyOptionsWrapper/AppendToBodyOptionsWrapper"));

var _styledComponents = require("../components/styledComponents/styledComponents");

var _filterOptions = _interopRequireDefault(require("./filterOptions"));

var _massageData = _interopRequireDefault(require("./massageData"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var noop = function noop() {};

var defaultProps = {
  onChange: undefined,
  onBlur: noop,
  onFocus: noop,
  name: undefined,
  selection: [],
  options: [],
  placeholder: 'Select...',
  multiple: false,
  disabled: false,
  creatable: false,
  removable: true,
  appendToBody: false,
  rightToLeft: false,
  filterOptions: _filterOptions.default,
  massageData: _massageData.default,
  optionKeys: ['value', 'label'],
  checkRadioMaxCount: 10,
  text: {
    placeholder: '',
    noOptions: 'No Options',
    create: 'Create'
  },
  components: {
    Select: undefined,
    CheckRadio: undefined,
    CheckBox: undefined,
    Radio: undefined,
    HtmlFieldData: _HtmlFieldData.default,
    Wrapper: _styledComponents.Wrapper,
    Selection: _styledComponents.Selection,
    SelectionList: _styledComponents.SelectionList,
    OptionList: _styledComponents.OptionList,
    Option: _styledComponents.Option,
    Search: _styledComponents.Search,
    SelectionWrapper: _styledComponents.SelectionWrapper,
    OptionWrapper: _styledComponents.OptionWrapper,
    AppendToBodyOptionsWrapper: _AppendToBodyOptionsWrapper.default,
    StyledAppendToBodyOptionsWrapper: _styledComponents.StyledAppendToBodyOptionsWrapper
  },
  styles: {
    fontSize: '1em',
    borderRadius: '.2em',
    paddingTop: '.25em',
    paddingBottom: '.25em',
    paddingLeft: '.25em',
    paddingRight: '.25em',
    selection: {
      paddingTop: '0',
      paddingBottom: '0',
      paddingLeft: '.2em',
      paddingRight: '.2em'
    },
    option: {
      paddingTop: '.25em',
      paddingBottom: '.25em',
      paddingLeft: '.25em',
      paddingRight: '.25em'
    },
    checkRadio: {
      borderWidth: '2px',
      marginBetween: '1em',
      labelMargin: '.2em',
      paddingTop: '.2em',
      paddingBottom: '.2em',
      paddingLeft: '.2em',
      paddingRight: '.2em'
    },
    search: {
      width: '10em'
    },
    icon: {
      width: '1em'
    },
    colors: {
      primary: 'black',
      secondary: '#C3C3C3',
      highlight: 'lightblue',
      warning: '#CD5C5C',
      disabled: '#ECECEC',
      background: 'white'
    }
  }
};
var _default = defaultProps;
exports.default = _default;