"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _without2 = _interopRequireDefault(require("lodash/without"));

var _sortBy2 = _interopRequireDefault(require("lodash/sortBy"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var filterOptions = function filterOptions(searchTerm, selection, options) {
  var searchProps = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : ['label', 'value'];
  options = _without2.default.apply(void 0, [options].concat(_toConsumableArray(selection)));
  if ((0, _isEmpty2.default)(searchTerm)) return options;
  searchTerm = searchTerm.toLowerCase();
  options = options.filter(function (item) {
    return item.label.toLowerCase().includes(searchTerm) || item.value.toLowerCase() === searchTerm;
  });
  options = (0, _sortBy2.default)(options, [function (item) {
    return item.label.toLowerCase() === searchTerm;
  }, function (item) {
    return item.value.toLowerCase() === searchTerm;
  }, function (item) {
    return item.label.toLowerCase().startsWith(searchTerm);
  }, function (item) {
    return item.label.toLowerCase().endsWith(searchTerm);
  }]).reverse(); // fuzzy search? https://fusejs.io/

  return options;
};

var _default = filterOptions;
exports.default = _default;