"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _castArray = _interopRequireDefault(require("lodash/castArray"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var massageData = function massageData(props) {
  var selection = props.selection,
      options = props.options,
      placeholder = props.placeholder,
      otherProps = _objectWithoutProperties(props, ["selection", "options", "placeholder"]); // Stringify


  selection = (0, _castArray.default)(selection).map(function (value) {
    return String(value);
  });
  options = options.map(function (option) {
    return {
      value: String(option[props.optionKeys[0]]),
      label: String(option[props.optionKeys[1]])
    };
  }); // Objectify

  var massagedSelection = selection.map(function (value) {
    var option = options.find(function (option) {
      return option.value === value;
    });
    return option == null ? {
      value: value,
      label: value
    } : option;
  });
  placeholder = otherProps.text.placeholder ? otherProps.text.placeholder : placeholder;
  return _objectSpread({}, otherProps, {
    selection: massagedSelection,
    options: options,
    text: _objectSpread({}, otherProps.text, {
      placeholder: placeholder
    })
  });
};

var _default = massageData;
exports.default = _default;